package com.huimv.admin.controller;


import com.huimv.admin.common.utils.Result;
import com.huimv.admin.service.IEnergyDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 耗能数据 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@RestController
@RequestMapping("/energy-data")
@CrossOrigin
public class EnergyDataController {

    @Autowired
    private IEnergyDataService iEnergyDataService;

    @RequestMapping("/listCount")
    public Result listCount(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listCount(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listData")
    public Result listData(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listData(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listRank")
    public Result listRank(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listRank(httpServletRequest, paramsMap);
    }

    //大屏
    @RequestMapping("/listDataScreen")
    public Result listDataScreen(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listDataScreen(httpServletRequest, paramsMap);
    }
}
