package com.huimv.admin.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 耗能数据
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("energy_data")
public class EnergyData implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 用料记录值
     */
    private String feedValue;

    /**
     * 用料原始值
     */
    private String originalFeedValue;

    /**
     * 用水记录值
     */
    private String waterValue;

    /**
     * 用水原始值
     */
    private String originalWaterValue;

    /**
     * 天然气记录值
     */
    private String gasValue;

    /**
     * 天然气原始值
     */
    private String originalGasValue;

    /**
     * 用电记录值
     */
    private String electricityValue;

    /**
     * 用电原始值
     */
    private String originalElectricityValue;

    /**
     * 原始数据
     */
    private String originalData;

    /**
     * 房舍id
     */
    private Integer unitId;

    private Integer farmId;

    private String other1;

    private String other2;

    private String other3;

    /*创建时间*/
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "GMT+8")
    private Date createDate;


}
