package com.huimv.admin.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 存栏结构
 * </p>
 *
 * @author author
 * @since 2023-02-22
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("prod_stock")
public class ProdStock implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 母猪存栏
     */
    private Integer mzcl;

    /**
     * 公猪存栏
     */
    private Integer gzcl;

    /**
     * 哺乳猪存栏
     */
    private Integer brzcl;

    /**
     * 保育猪存栏
     */
    private Integer byzcl;

    /**
     * 育肥猪存栏
     */
    private Integer yfzcl;

    /**
     * 后备猪存栏
     */
    private Integer hbzcl;

    /**
     * 妊娠猪存栏
     */
    private Integer rszcl;

    /**
     * 哺乳母猪存栏
     */
    private Integer brmzcl;

    /**
     * 空怀猪存栏
     */
    private Integer khzcl;

    /**
     * 公猪存栏
     */
    private Integer spzcl;

    /**
     * 商品猪存栏
     */
    @JsonFormat(pattern = "yyyy-MM",timezone = "GMT+8")
    private LocalDateTime creatTime;

    private Integer farmId;

    private String other1;

    private String other2;

    private String other3;


}
