package com.huimv.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.ProdStock;
import com.huimv.admin.entity.vo.ProdStockVo;
import com.huimv.admin.mapper.ProdStockMapper;
import com.huimv.admin.service.IProdStockService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 存栏结构 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-22
 */
@Service
public class ProdStockServiceImpl extends ServiceImpl<ProdStockMapper, ProdStock> implements IProdStockService {

    @Autowired
    private ProdStockMapper prodStockMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");


        QueryWrapper<ProdStock> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); //格式化时间
        //获取前12个月的第一天
        Calendar cal_1 = Calendar.getInstance();//获取当前日期
        cal_1.add(Calendar.MONTH, -12);
        cal_1.set(Calendar.DAY_OF_MONTH, 1);//设置为1号
        cal_1.set(Calendar.HOUR_OF_DAY, 0);
        cal_1.set(Calendar.MINUTE, 0);
        cal_1.set(Calendar.SECOND, 0);
        String firstDay = format.format(cal_1.getTime());
        queryWrapper.ge("creat_time", firstDay);
        List<ProdStock> prodStocks = prodStockMapper.listDay(queryWrapper);

        QueryWrapper<ProdStock> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("farm_id", farmId).orderByDesc("creat_time").last(" limit 1");
        ProdStock prodStock = prodStockMapper.selectOne(queryWrapper1);
        Integer count = prodStock.getMzcl() + prodStock.getGzcl() + prodStock.getBrzcl() + prodStock.getByzcl() + prodStock.getYfzcl() +
                prodStock.getHbzcl() + prodStock.getRszcl() + prodStock.getBrmzcl() + prodStock.getKhzcl() + prodStock.getSpzcl();
        NumberFormat nt = NumberFormat.getPercentInstance();
        nt.setMinimumFractionDigits(2);

        ProdStockVo prodStockVo = new ProdStockVo();
        prodStockVo.setCount(count);
        prodStockVo.setProdStock(prodStock);
        prodStockVo.setProdStocks(prodStocks);
        prodStockVo.setMzclTRate(nt.format((double)prodStock.getMzcl()/count));
        prodStockVo.setGzclTRate(nt.format((double) prodStock.getGzcl() / count));
        prodStockVo.setBrzclTRate(nt.format((double) prodStock.getBrzcl() / count));
        prodStockVo.setByzclTRate(nt.format((double) prodStock.getByzcl() / count));
        prodStockVo.setYfzclRate(nt.format((double) prodStock.getYfzcl() / count));
        prodStockVo.setHbzclRate(nt.format((double) prodStock.getHbzcl() / count));
        prodStockVo.setRczclTRate(nt.format((double) prodStock.getRszcl() / count));
        prodStockVo.setBrmzclRate(nt.format((double) prodStock.getBrmzcl() / count));
        prodStockVo.setKhzclRate(nt.format((double) prodStock.getKhzcl() / count));
        prodStockVo.setSpzclRate(nt.format((double) prodStock.getSpzcl() / count));
        return new Result(ResultCode.SUCCESS,prodStockVo);
    }
}
