package com.huimv.admin.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.DataUill;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.ProtData;
import com.huimv.admin.entity.ProtWarningInfo;
import com.huimv.admin.entity.dto.ProCountDto;
import com.huimv.admin.entity.vo.ProCountVo;
import com.huimv.admin.entity.vo.ProDataVo;
import com.huimv.admin.mapper.ProtDataMapper;
import com.huimv.admin.mapper.ProtWarningInfoMapper;
import com.huimv.admin.service.IProtDataService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@Service
public class ProtDataServiceImpl extends ServiceImpl<ProtDataMapper, ProtData> implements IProtDataService {

    @Autowired
    private ProtDataMapper protDataMapper;
    @Autowired
    private ProtWarningInfoMapper protWarningInfoMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String loctionType = paramsMap.get("loctionType");
        String startTime = paramsMap.get("startTime");
        String endTime = paramsMap.get("endTime");
        String type = paramsMap.get("type");
        String dataType = paramsMap.get("dataType");

        if (type == null || type == "") {
            type = "1";
        }
        if (dataType == null || dataType == "") {
            dataType = "1";
        }
        QueryWrapper<ProtData> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);

        List<ProtData> protDataList = null;
        ProCountDto proCountDto = new ProCountDto();
        //ph
        if ("1".equals(dataType)) {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listPh(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listPh(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listPh(queryWrapper3);

                proCountDto.setOutList(protData3);


               // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listPh(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listPh(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listPh(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listPh(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listPh(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listPh(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listPh(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listPh(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listPh(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        //cod
        else if ("2".equals(dataType))  {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listCod(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listCod(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listCod(queryWrapper3);

                proCountDto.setOutList(protData3);


                // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listCod(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listCod(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listCod(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listCod(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listCod(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listCod(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listCod(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listCod(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listCod(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        //NH3N
        else if ("3".equals(dataType))  {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listNh3n(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listNh3n(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listNh3n(queryWrapper3);

                proCountDto.setOutList(protData3);


                // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listNh3n(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listNh3n(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listNh3n(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listNh3n(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listNh3n(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listNh3n(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listNh3n(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listNh3n(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listNh3n(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        //TP
        else if ("4".equals(dataType)) {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTp(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTp(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTp(queryWrapper3);

                proCountDto.setOutList(protData3);


                // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTp(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTp(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTp(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTp(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTp(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTp(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTp(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTp(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTp(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        //TN
        else if ("5".equals(dataType))  {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTn(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTn(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTn(queryWrapper3);

                proCountDto.setOutList(protData3);


                // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTn(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTn(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTn(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTn(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTn(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTn(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listTn(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listTn(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listTn(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        //FLOW
        else if ("6".equals(dataType)) {
            if ("4".equals(type)) {
                startTime = startTime + " 00:00:00";
                endTime = endTime + " 23:59:59";
                queryWrapper.between("create_date",startTime, endTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listFlow(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id", farmId);
                queryWrapper2.between("create_date",startTime, endTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listFlow(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id", farmId);
                queryWrapper3.between("create_date",startTime, endTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listFlow(queryWrapper3);

                proCountDto.setOutList(protData3);


                // protDataList=endList;
            }
            //本年
            else if ("3".equals(type)) {
                Calendar dateTime = Calendar.getInstance();
                int i = dateTime.get(Calendar.YEAR);
                // DateTime dateTime = DateUtil.beginOfYear(new Date());
                queryWrapper.ge("create_date", i);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listFlow(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listFlow(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", i);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listFlow(queryWrapper3);
                proCountDto.setOutList(protData3);



            }
            //本月
            else if ("2".equals(type)) {
                Date timesMonthmorning = DataUill.getTimesMonthmorning();
                queryWrapper.ge("create_date", timesMonthmorning);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listFlow(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listFlow(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", timesMonthmorning);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listFlow(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
            //本周
            else if ("1".equals(type)) {
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
                Date dateTime = calendar.getTime();

                queryWrapper.ge("create_date", dateTime);
                queryWrapper.eq("loction_type" ,1);
                List<ProCountVo> protData1 = protDataMapper.listFlow(queryWrapper);
                proCountDto.setInList(protData1);

                QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper2.eq("loction_type" ,2);
                List<ProCountVo> protData2 = protDataMapper.listFlow(queryWrapper2);
                proCountDto.setDealList(protData2);

                QueryWrapper<ProtData> queryWrapper3 = new QueryWrapper<>();
                queryWrapper3.eq("farm_id",farmId).ge("create_date", dateTime);
                queryWrapper3.eq("loction_type" ,3);
                List<ProCountVo> protData3 = protDataMapper.listFlow(queryWrapper3);
                proCountDto.setOutList(protData3);


            }
        }
        return new Result(ResultCode.SUCCESS, proCountDto);
    }

    @Override
    public Result listProt(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {

        String farmId = paramsMap.get("farmId");
        QueryWrapper<ProtWarningInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).orderByDesc("date").last(" limit 10");
        List<ProtWarningInfo> protWarningInfos = protWarningInfoMapper.selectList(queryWrapper);
        //今日
        Date timesmorning = DataUill.getTimesmorning();
        //本周
        DateTime dateTime = DateUtil.beginOfWeek(new Date());

        //本月
        Date timesMonthmorning = DataUill.getTimesMonthmorning();

        List<ProDataVo> voList = new LinkedList<>();
        for (int i = 0; i < protWarningInfos.size(); i++) {
            ProDataVo proDataVo = new ProDataVo();
            proDataVo.setContent(protWarningInfos.get(i).getWarningContent());
            proDataVo.setTime(protWarningInfos.get(i).getDate());
            voList.add(proDataVo);
        }
        QueryWrapper<ProtWarningInfo> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("farm_id", farmId).ge("date",timesmorning);
        Integer dayCount = protWarningInfoMapper.selectCount(queryWrapper1);

        QueryWrapper<ProtWarningInfo> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.eq("farm_id", farmId).ge("date",dateTime);
        Integer weekCount= protWarningInfoMapper.selectCount(queryWrapper2);

        QueryWrapper<ProtWarningInfo> queryWrapper3 = new QueryWrapper<>();
        queryWrapper3.eq("farm_id", farmId).ge("date",timesMonthmorning);
        Integer monthCount  = protWarningInfoMapper.selectCount(queryWrapper3);

        QueryWrapper<ProtWarningInfo> queryWrapper4 = new QueryWrapper<>();
        queryWrapper4.eq("farm_id", farmId);
        Integer count  = protWarningInfoMapper.selectCount(queryWrapper4);

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("dayCount", dayCount);
        jsonObject.put("weekCount", weekCount);
        jsonObject.put("monthCount", monthCount);
        jsonObject.put("count", count);
        jsonObject.put("data", voList);


        return new Result(ResultCode.SUCCESS,jsonObject);
    }

    @Override
    public Result listType(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<ProtData> queryWrapper = new QueryWrapper<>();
       // ProCountDto proCountDto = new ProCountDto();
        JSONObject jsonObject = new JSONObject();

        queryWrapper.eq("farm_id", farmId).eq("loction_type", 1).orderByDesc("create_date").last(" limit 1");
        ProtData protData = protDataMapper.selectOne(queryWrapper);
        jsonObject.put("in", protData);

        QueryWrapper<ProtData> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("farm_id", farmId).eq("loction_type", 2).orderByDesc("create_date").last(" limit 1");
        ProtData protData1 = protDataMapper.selectOne(queryWrapper1);
        jsonObject.put("deal", protData1);

        QueryWrapper<ProtData> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.eq("farm_id", farmId).eq("loction_type", 3).orderByDesc("create_date").last(" limit 1");
        ProtData protData2 = protDataMapper.selectOne(queryWrapper2);
        jsonObject.put("out", protData2);

        return new Result(ResultCode.SUCCESS,jsonObject);
    }


}
