package com.huimv.admin.timer;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.NumberUtils;
import com.huimv.admin.entity.EnergyData;
import com.huimv.admin.entity.EnergyEnvDevice;
import com.huimv.admin.mapper.EnergyDataMapper;
import com.huimv.admin.mapper.EnergyEnvDeviceMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.util.Date;
import java.util.List;

@Configuration
@EnableScheduling
public class EnergyTimer {

    @Autowired
    private EnergyEnvDeviceMapper deviceMapper;
    @Autowired
    private EnergyDataMapper dataMapper;

//    能耗数据
    @Scheduled(cron = "0 0/10 * * * ? ")
    private void getShenChan() throws Exception {


        List<EnergyEnvDevice> energyEnvDevices = deviceMapper.selectList(null);
        for (EnergyEnvDevice energyEnvDevice : energyEnvDevices) {
            EnergyData energyData = new EnergyData();
            energyData.setCreateDate(new Date());
            energyData.setFarmId(energyEnvDevice.getFarmId());
            energyData.setUnitId(energyEnvDevice.getUnitId());
            energyData.setFeedValue(NumberUtils.getNum(80, 100, 1));
            energyData.setWaterValue(NumberUtils.getNum(1, 5, 1));
            energyData.setGasValue(NumberUtils.getNum(1, 5, 1));
            energyData.setElectricityValue(NumberUtils.getNum(5, 10, 1));
            dataMapper.insert(energyData);
        }
    }
}
